﻿TACTIC_MSG_CH = "TTC2"
TACTIC_TEMP_MSG = {}
local lastSelected = 0
local lastReceived = 0
local message1
local message2
local message3
local message4
local templates={
	["EncounterInstanceButtonTemplate"]=true,
	["EncounterBossButtonTemplate"]=true,
	["EncounterItemTemplate"]=true,
	["EncounterInfoTemplate"]=true,
}
function Tacticator_toggle_visible()
  if(Tacticator:IsShown()) then
    Tacticator:Hide()
    TacticatorActors:Hide()
	TacticatorList:Hide()
	TacticatorList:Hide()
  else
    Tacticator:Show()
	TacticatorList:Show()
  end
end

function TacticDisplay_Toggle_Visible()
	if(TacticDisplay:IsShown()) then
		TacticDisplay:Hide()
	else
		TacticDisplay:Show()
	end
end

function TacticButtons_Toggle_Visible()
	if TacticButtons:IsShown() then
		TacticButtons_OnClose()
	else
		Tacticator_ShowButtons()
	end
end

local function Tacticator_CreateHookedFrame(ftype,fname,fparent,template)
	if template and templates[template] then
		if not fname then return end
		local button = _G[fname].button or _G[fname]
		if button and button:IsObjectType("Button") then
			if button.hooked then return end
			button:HookScript("OnClick",Tacticator_InsertJournalLink)
			button.hooked = true
		end
	end
end

function Tacticator_OnLoad(self)
  local version = GetAddOnMetadata("Tacticator", "Version")
  Tacticator_SetVariables()
  self:SetScript("OnEvent", Tacticator_OnEvent)
  self:RegisterEvent("VARIABLES_LOADED")

  SlashCmdList["Tacticator"] = function(msg)
    Tacticator_SlashCommand(msg)
  end
  SLASH_Tacticator1 = "/tacticator"
  
  if( DEFAULT_CHAT_FRAME ) then
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Tacticator v"..version.." loaded")
  end
  UIErrorsFrame:AddMessage("Tacticator v"..version.." AddOn loaded", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME)
  if moblist then
  	TacticatorTacticGD:Enable()
  else
  	TacticatorTacticGD:Disable()
  end
  Tacticator:Hide()
end

function TacticDisplay_OnLoad(self)
  self:SetScript("OnEvent", TacticDisplay_OnEvent)
  self:RegisterEvent("CHAT_MSG_ADDON")
  TacticDisplay:Hide()
  TacticatorActors:Hide()
end

function Tacticator_OnEvent(self, event, ...)
	if (event=="VARIABLES_LOADED") then
		Tacticator:ClearAllPoints()
		Tacticator:SetPoint("BOTTOMLEFT","UIParent", "BOTTOMLEFT", TacticatorSavings.dispx, TacticatorSavings.dispy)
		TacticDisplay:SetPoint("BOTTOMLEFT","UIParent", "BOTTOMLEFT", TacticatorSavings.historyDispx, TacticatorSavings.historyDispy)
		TacticButtons:ClearAllPoints()
		TacticButtons:SetPoint("BOTTOMLEFT","UIParent", "BOTTOMLEFT", TacticatorSavings.buttonsDispx, TacticatorSavings.buttonsDispy)
		local i
		if not(TacticatorSavings.TACTIC_INSTANCE) then
			TacticatorSavings.TACTIC_INSTANCE = {}
		end
		TacticatorConfig_OnCancelOrLoad()
	end
end

function TacticatorConfig_OnCancelOrLoad()
	TacticatorConfigFrameRaid:SetChecked(TacticatorSavings.showRaid)
	TacticatorConfigFrameParty:SetChecked(TacticatorSavings.showParty)
	TacticatorConfigFrameBG:SetChecked(TacticatorSavings.showBG)
	TacticatorConfigFrameInstance:SetChecked(TacticatorSavings.showInstance)
	TacticatorConfigFramePopup:SetChecked(TacticatorSavings.showPopup)
	TacticatorConfigFramePopupOwn:SetChecked(TacticatorSavings.showPopupOwn)
end

function Tacticator_SetVariables()
  if not(TacticatorSavings) then
    TacticatorSavings = {}
    TacticatorSavings.dispx = GetScreenWidth()/2 - 200
    TacticatorSavings.dispy = GetScreenHeight()/2 - 200
	TacticatorSavings.historyDispx = GetScreenWidth()/2 - 200
	TacticatorSavings.historyDispy = GetScreenHeight()/2 - 200
	TacticatorSavings.buttonsDispx = GetScreenWidth()/2 - 200
	TacticatorSavings.buttonsDispy = GetScreenHeight()/2 - 200
    TacticatorSavings.TACTIC_INSTANCE = {}
    TacticatorSavings.showRaid = true
    TacticatorSavings.showParty = true
    TacticatorSavings.showBG = true
    TacticatorSavings.showInstance = true
    TacticatorSavings.showPopup = true
    TacticatorSavings.showPopupOwn = false
  end
  if not TacticatorSavings.showInstance then
	TacticatorSavings.showInstance = true
  end
  if not TacticatorSavings.buttonsDispx then
	TacticatorSavings.buttonsDispx = GetScreenWidth()/2 - 200
	TacticatorSavings.buttonsDispy = GetScreenHeight()/2 - 200
  end
end

function Tacticator_SlashCommand(msg)
  if(msg) then
    local command = string.lower(msg)
    if(command == "hide") then
		Tacticator:Hide()
    elseif(command == "history") then
	    TacticDisplay:Show()
	elseif(command == "buttons") then
		TacticButtons:Show()
	else
    	Tacticator_toggle_visible()
    end
  end
end

function Tacticator_SavePosition(self)
  TacticatorSavings.dispx = self:GetLeft()
  TacticatorSavings.dispy = self:GetBottom()
end

function TacticatorDisplay_SavePosition(self)
  TacticatorSavings.historyDispx = self:GetLeft()
  TacticatorSavings.historyDispy = self:GetBottom()
end

function Tacticator_OnSave()
	local instance = lastSelected
	local box = _G["TacticatorScrollContainerScrollFrameEditBox"]
	local tacticText = box:GetText()
	if (instance == 0) then
		instance = lastSelected
	end
	if(instance == 0) then
		return
	end
	if tacticText and not(tacticText == "") and instance then
		TacticatorSavings.TACTIC_INSTANCE[instance].tactic = tacticText
		if not(TacticatorSavings.TACTIC_INSTANCE[instance].actors) then
			TacticatorSavings.TACTIC_INSTANCE[instance].actors = {}
		end
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h1"] = TacticatorActorsHealerTabH1:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h2"] = TacticatorActorsHealerTabH2:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h3"] = TacticatorActorsHealerTabH3:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h4"] = TacticatorActorsHealerTabH4:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h5"] = TacticatorActorsHealerTabH5:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h6"] = TacticatorActorsHealerTabH6:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h7"] = TacticatorActorsHealerTabH7:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h8"] = TacticatorActorsHealerTabH8:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["h9"] = TacticatorActorsHealerTabH9:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t1"] = TacticatorActorsTankTabT1:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t2"] = TacticatorActorsTankTabT2:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t3"] = TacticatorActorsTankTabT3:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t4"] = TacticatorActorsTankTabT4:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t5"] = TacticatorActorsTankTabT5:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t6"] = TacticatorActorsTankTabT6:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t7"] = TacticatorActorsTankTabT7:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t8"] = TacticatorActorsTankTabT8:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["t9"] = TacticatorActorsTankTabT9:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d1"] = TacticatorActorsDPSTabD1:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d2"] = TacticatorActorsDPSTabD2:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d3"] = TacticatorActorsDPSTabD3:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d4"] = TacticatorActorsDPSTabD4:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d5"] = TacticatorActorsDPSTabD5:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d6"] = TacticatorActorsDPSTabD6:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d7"] = TacticatorActorsDPSTabD7:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d8"] = TacticatorActorsDPSTabD8:GetText()
		TacticatorSavings.TACTIC_INSTANCE[instance].actors["d9"] = TacticatorActorsDPSTabD9:GetText()
	end
end

function Tacticator_OnAdd()
	local instance = _G["TacticatorListInstance"]
	local text = instance:GetText()
	if text and not(text == "") then
		tactic = {
			name = text;
			tactic = "";
		}
		TacticatorSavings.TACTIC_INSTANCE[getn(TacticatorSavings.TACTIC_INSTANCE) + 1] = tactic
	end
	instance:SetText("")
	Tacticator_InstanceScrollBar_Update()
	instance:ClearFocus()
end

function Tacticator_OnRename()
	local instanceSelected = lastSelected
	local instance = _G["TacticatorListInstance"]
	local text = instance:GetText()
	if text and not(text == "") and instanceSelected and (instanceSelected > 0) then
		TacticatorSavings.TACTIC_INSTANCE[instanceSelected].name = text
		instance:SetText("")
		Tacticator_InstanceScrollBar_Update()
	end
	instance:ClearFocus()
	lastSelected = 0
end

function Tacticator_OnClear()
  local obj = _G["TacticatorScrollContainerScrollFrameEditBox"]
  obj:SetText("")
end

function Tacticator_OnClose()
  Tacticator:Hide()
  TacticatorActors:Hide()
  TacticatorList:Hide()
end

function TacticDisplay_OnClose()
  TacticDisplay:Hide()
end

function TacticDisplayDropDownReceived_Initialize()
	local i
	if(getn(TACTIC_TEMP_MSG) > 0) then
		for i = 1, getn(TACTIC_TEMP_MSG), 1 do
			info = {
				text = TACTIC_TEMP_MSG[i].sender.." : "..i;
				func = TacticDisplayDropDownReceived_OnClick;
			}
			UIDropDownMenu_AddButton(info)
			i = i + 1
		end
	end
end

function TacticDisplayDropDownReceived_OnShow()
	UIDropDownMenu_Initialize(TacticDisplayDropDownReceived, TacticDisplayDropDownReceived_Initialize)
	if lastReceived then
		UIDropDownMenu_SetSelectedID(TacticDisplayDropDownReceived, lastReceived)
	else
		UIDropDownMenu_SetSelectedID(TacticDisplayDropDownReceived, 0)
	end
	UIDropDownMenu_SetWidth(TacticDisplayDropDownReceived, 100)
end

function TacticDisplayDropDownReceived_OnClick(self)
	local thisID = self:GetID()
	lastReceived = thisID
	UIDropDownMenu_SetSelectedID(TacticDisplayDropDownReceived, thisID)
	local box = _G["TacticDisplayScrollContainerScrollFrameEditBox"]
	box:SetText(strsub(TACTIC_TEMP_MSG[thisID].tactic, 1, strlen(TACTIC_TEMP_MSG[thisID].tactic)-1))
end

function Tacticator_OnDelete()
	local id = lastSelected
	lastSelected = 0
	if id == 0 then
		return
	end
	tremove(TacticatorSavings.TACTIC_INSTANCE, id)
	Tacticator_InstanceScrollBar_Update()
	local box = _G["TacticatorScrollContainerScrollFrameEditBox"]
	box:SetText("")
end

function TacticatorListDropDownInstance_OnClick(self)
	local thisID = self:GetID()
	TacticatorPrepareMessage(thisID)
end

function TacticatorPrepareMessage(thisID)
	lastSelected = thisID
	local box = _G["TacticatorScrollContainerScrollFrameEditBox"]
	box:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].tactic)
	if(TacticatorSavings.TACTIC_INSTANCE[thisID].actors) then
		TacticatorActorsHealerTabH1:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h1"])
		TacticatorActorsHealerTabH2:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h2"])
		TacticatorActorsHealerTabH3:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h3"])
		TacticatorActorsHealerTabH4:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h4"])
		TacticatorActorsHealerTabH5:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h5"])
		TacticatorActorsHealerTabH6:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h6"])
		TacticatorActorsHealerTabH7:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h7"])
		TacticatorActorsHealerTabH8:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h8"])
		TacticatorActorsHealerTabH9:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["h9"])
		TacticatorActorsTankTabT1:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t1"])
		TacticatorActorsTankTabT2:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t2"])
		TacticatorActorsTankTabT3:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t3"])
		TacticatorActorsTankTabT4:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t4"])
		TacticatorActorsTankTabT5:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t5"])
		TacticatorActorsTankTabT6:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t6"])
		TacticatorActorsTankTabT7:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t7"])
		TacticatorActorsTankTabT8:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t8"])
		TacticatorActorsTankTabT9:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["t9"])
		TacticatorActorsDPSTabD1:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d1"])
		TacticatorActorsDPSTabD2:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d2"])
		TacticatorActorsDPSTabD3:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d3"])
		TacticatorActorsDPSTabD4:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d4"])
		TacticatorActorsDPSTabD5:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d5"])
		TacticatorActorsDPSTabD6:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d6"])
		TacticatorActorsDPSTabD7:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d7"])
		TacticatorActorsDPSTabD8:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d8"])
		TacticatorActorsDPSTabD9:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].actors["d9"])
	else 
		TacticatorActorsHealerTabH1:SetText("")
		TacticatorActorsHealerTabH2:SetText("")
		TacticatorActorsHealerTabH3:SetText("")
		TacticatorActorsHealerTabH4:SetText("")
		TacticatorActorsHealerTabH5:SetText("")
		TacticatorActorsHealerTabH6:SetText("")
		TacticatorActorsHealerTabH7:SetText("")
		TacticatorActorsHealerTabH8:SetText("")
		TacticatorActorsHealerTabH9:SetText("")
		TacticatorActorsTankTabT1:SetText("")
		TacticatorActorsTankTabT2:SetText("")
		TacticatorActorsTankTabT3:SetText("")
		TacticatorActorsTankTabT4:SetText("")
		TacticatorActorsTankTabT5:SetText("")
		TacticatorActorsTankTabT6:SetText("")
		TacticatorActorsTankTabT7:SetText("")
		TacticatorActorsTankTabT8:SetText("")
		TacticatorActorsTankTabT9:SetText("")
		TacticatorActorsDPSTabD1:SetText("")
		TacticatorActorsDPSTabD2:SetText("")
		TacticatorActorsDPSTabD3:SetText("")
		TacticatorActorsDPSTabD4:SetText("")
		TacticatorActorsDPSTabD5:SetText("")
		TacticatorActorsDPSTabD6:SetText("")
		TacticatorActorsDPSTabD7:SetText("")
		TacticatorActorsDPSTabD8:SetText("")
		TacticatorActorsDPSTabD9:SetText("")
	end
end

function Tacticator_OnSayClick()
	_G["TacticatorCheckParty"]:SetChecked(false)
	_G["TacticatorCheckSay"]:SetChecked(true)
	_G["TacticatorCheckRaid"]:SetChecked(false)
	_G["TacticatorCheckRaidWarning"]:SetChecked(false)
	_G["TacticatorCheckBattleground"]:SetChecked(false)
	_G["TacticatorCheckChannelNo"]:SetChecked(false)
	_G["TacticatorCheckInstance"]:SetChecked(false)
end

function Tacticator_OnPartyClick()
	_G["TacticatorCheckParty"]:SetChecked(true)
	_G["TacticatorCheckSay"]:SetChecked(false)
	_G["TacticatorCheckRaid"]:SetChecked(false)
	_G["TacticatorCheckRaidWarning"]:SetChecked(false)
	_G["TacticatorCheckBattleground"]:SetChecked(false)
	_G["TacticatorCheckChannelNo"]:SetChecked(false)
	_G["TacticatorCheckInstance"]:SetChecked(false)
end

function Tacticator_OnRaidClick()
	_G["TacticatorCheckParty"]:SetChecked(false)
	_G["TacticatorCheckSay"]:SetChecked(false)
	_G["TacticatorCheckRaid"]:SetChecked(true)
	_G["TacticatorCheckRaidWarning"]:SetChecked(false)
	_G["TacticatorCheckBattleground"]:SetChecked(false)
	_G["TacticatorCheckChannelNo"]:SetChecked(false)
	_G["TacticatorCheckInstance"]:SetChecked(false)
end

function Tacticator_OnInstanceClick()
	_G["TacticatorCheckParty"]:SetChecked(false)
	_G["TacticatorCheckSay"]:SetChecked(false)
	_G["TacticatorCheckRaid"]:SetChecked(false)
	_G["TacticatorCheckRaidWarning"]:SetChecked(false)
	_G["TacticatorCheckBattleground"]:SetChecked(false)
	_G["TacticatorCheckChannelNo"]:SetChecked(false)
	_G["TacticatorCheckInstance"]:SetChecked(true)
end

function Tacticator_OnRaidWarningClick()
	_G["TacticatorCheckParty"]:SetChecked(false)
	_G["TacticatorCheckSay"]:SetChecked(false)
	_G["TacticatorCheckRaid"]:SetChecked(false)
	_G["TacticatorCheckRaidWarning"]:SetChecked(true)
	_G["TacticatorCheckBattleground"]:SetChecked(false)
	_G["TacticatorCheckChannelNo"]:SetChecked(false)
	_G["TacticatorCheckInstance"]:SetChecked(false)
end

function Tacticator_OnBattlegroundClick()
	_G["TacticatorCheckParty"]:SetChecked(false)
	_G["TacticatorCheckSay"]:SetChecked(false)
	_G["TacticatorCheckRaid"]:SetChecked(false)
	_G["TacticatorCheckRaidWarning"]:SetChecked(false)
	_G["TacticatorCheckBattleground"]:SetChecked(true)
	_G["TacticatorCheckChannelNo"]:SetChecked(false)
	_G["TacticatorCheckInstance"]:SetChecked(false)
end

function Tacticator_OnChannelNoClick()
	_G["TacticatorCheckParty"]:SetChecked(false)
	_G["TacticatorCheckSay"]:SetChecked(false)
	_G["TacticatorCheckRaid"]:SetChecked(false)
	_G["TacticatorCheckRaidWarning"]:SetChecked(false)
	_G["TacticatorCheckBattleground"]:SetChecked(false)
	_G["TacticatorCheckChannelNo"]:SetChecked(true)
	_G["TacticatorCheckInstance"]:SetChecked(false)
end

function TacticatorGetLink(text, linktype, id, id2)
	--DEFAULT_CHAT_FRAME:AddMessage("test: "..text.." "..linktype.." "..id)
	if linktype == "spell" then
		local link = GetSpellLink(id)
		return link
	end
	if linktype == "item" then
		local name, link = GetItemInfo(id)
		return link 
	end
	if linktype == "journal" then
		--DEFAULT_CHAT_FRAME:AddMessage("test: "..text.." "..linktype.." "..id..":"..id2)
		if id == "0" then
			local _, _, _, _, _, _, sectionLink = EJ_GetInstanceInfo(id2)
			return sectionLink
		elseif id == "1" then
			local _, _, _, _, sectionLink = EJ_GetEncounterInfo(id2)
			return sectionLink
		elseif id == "2" then
			local _, _, _, _, _, _, _, _, sectionLink, startsOpen, specialFlags, u4, u5, u6 = EJ_GetSectionInfo(id2)
			return sectionLink
		end
	return sectionLink
	end
end

function Tacticator_OnSend()
	local box = _G["TacticatorScrollContainerScrollFrameEditBox"]
	local tacticText = box:GetText()
	tacticText = gsub(tacticText, "{T1}", TacticatorActorsTankTabT1:GetText())
	tacticText = gsub(tacticText, "{T2}", TacticatorActorsTankTabT2:GetText())
	tacticText = gsub(tacticText, "{T3}", TacticatorActorsTankTabT3:GetText())
	tacticText = gsub(tacticText, "{T4}", TacticatorActorsTankTabT4:GetText())
	tacticText = gsub(tacticText, "{T5}", TacticatorActorsTankTabT5:GetText())
	tacticText = gsub(tacticText, "{T6}", TacticatorActorsTankTabT6:GetText())
	tacticText = gsub(tacticText, "{T7}", TacticatorActorsTankTabT7:GetText())
	tacticText = gsub(tacticText, "{T8}", TacticatorActorsTankTabT8:GetText())
	tacticText = gsub(tacticText, "{T9}", TacticatorActorsTankTabT9:GetText())
	tacticText = gsub(tacticText, "{H1}", TacticatorActorsHealerTabH1:GetText())
	tacticText = gsub(tacticText, "{H2}", TacticatorActorsHealerTabH2:GetText())
	tacticText = gsub(tacticText, "{H3}", TacticatorActorsHealerTabH3:GetText())
	tacticText = gsub(tacticText, "{H4}", TacticatorActorsHealerTabH4:GetText())
	tacticText = gsub(tacticText, "{H5}", TacticatorActorsHealerTabH5:GetText())
	tacticText = gsub(tacticText, "{H6}", TacticatorActorsHealerTabH6:GetText())
	tacticText = gsub(tacticText, "{H7}", TacticatorActorsHealerTabH7:GetText())
	tacticText = gsub(tacticText, "{H8}", TacticatorActorsHealerTabH8:GetText())
	tacticText = gsub(tacticText, "{H9}", TacticatorActorsHealerTabH9:GetText())
	tacticText = gsub(tacticText, "{D1}", TacticatorActorsDPSTabD1:GetText())
	tacticText = gsub(tacticText, "{D2}", TacticatorActorsDPSTabD2:GetText())
	tacticText = gsub(tacticText, "{D3}", TacticatorActorsDPSTabD3:GetText())
	tacticText = gsub(tacticText, "{D4}", TacticatorActorsDPSTabD4:GetText())
	tacticText = gsub(tacticText, "{D5}", TacticatorActorsDPSTabD5:GetText())
	tacticText = gsub(tacticText, "{D6}", TacticatorActorsDPSTabD6:GetText())
	tacticText = gsub(tacticText, "{D7}", TacticatorActorsDPSTabD7:GetText())
	tacticText = gsub(tacticText, "{D8}", TacticatorActorsDPSTabD8:GetText())
	tacticText = gsub(tacticText, "{D9}", TacticatorActorsDPSTabD9:GetText())
	tacticText = gsub(tacticText, "(|cff%x%x%x%x%x%x)", "")
	local addonText = tacticText
	tacticText = gsub(tacticText, "{((%w+):(%d+)):(%d*):?.-}", TacticatorGetLink)
	local continueVar = true
	local channel = "RAID"
	local no = nil
	local channelRequired = false
	if(_G["TacticatorCheckParty"]:GetChecked()) then
		channel = "PARTY"
	elseif(_G["TacticatorCheckSay"]:GetChecked()) then
		channel = "SAY"
	elseif(_G["TacticatorCheckRaidWarning"]:GetChecked()) then
		channel = "RAID_WARNING"
	elseif(_G["TacticatorCheckBattleground"]:GetChecked()) then
		channel = "BATTLEGROUND"
	elseif(_G["TacticatorCheckInstance"]:GetChecked()) then
		channel = "INSTANCE_CHAT"
	elseif(_G["TacticatorCheckChannelNo"]:GetChecked()) then
		channel = "CHANNEL"
		no = _G["TacticatorChannelNo"]:GetText()
		channelRequired = true
	end
	local tempChannel
	if(channel == "PARTY" or channel == "RAID" or channel == "BATTLEGROUND" or channel == "RAID_WARNING" or channel == "INSTANCE_CHAT") then
		if(channel == "RAID_WARNING") then
			tempChannel = "RAID"
		else
			tempChannel = channel
		end
	end
	if((not(no) or (no == "")) and channelRequired) then
	else
		while (tempChannel and continueVar == true) do
			local pos1 = strfind(addonText, strchar(10))
			if(not(pos1) and (strlen(addonText)+strlen(TACTIC_MSG_CH) > 253 )) then
				pos1 = 253-strlen(TACTIC_MSG_CH)
			end
			if(pos1) then
				if(pos1+strlen(TACTIC_MSG_CH) > 253) then
					pos1 = 253 - strlen(TACTIC_MSG_CH)
				end
				SendAddonMessage(TACTIC_MSG_CH, strsub(addonText,1,pos1), tempChannel)
				addonText = strsub(addonText, pos1+1)
			else
				SendAddonMessage(TACTIC_MSG_CH, addonText, tempChannel)
				continueVar = false
			end
		end
		SendAddonMessage(TACTIC_MSG_CH, strchar(23), tempChannel)
		continueVar = true
		while (continueVar == true) do
			local pos1 = strfind(tacticText, strchar(10))
			if(not(pos1) and (strlen(tacticText) > 253 )) then
				pos1 = 253
			end
			if(pos1) then
				if(pos1 > 253) then
					pos1 = 253
				end
				if(no) then
					SendChatMessage(strsub(tacticText,1,pos1), channel, nil, no)
				else
					SendChatMessage(strsub(tacticText,1,pos1), channel)
				end

				tacticText = strsub(tacticText, pos1+1)
			else
				if(strlen(tacticText) > 0) then
					if(no) then
						SendChatMessage(tacticText, channel, nil, no)
					else
						SendChatMessage(tacticText, channel)
					end
				end
				continueVar = false
			end
		end
	end
end

function TacticDisplay_OnEvent(self, event, arg1, arg2, arg3, arg4)
	if(event =="CHAT_MSG_ADDON") then
		TacticDisplay_HandleMessage(arg1, arg2, arg3, arg4)
	end
end

function TacticDisplay_HandleMessage(prefix, text, channel, sender)
	if(prefix == TACTIC_MSG_CH and ((channel == "RAID" and TacticatorSavings.showRaid) or (channel == "PARTY" and TacticatorSavings.showParty) or (channel == "BATTLEGROUND" and TacticatorSavings.showBG) or (channel == "INSTANCE_CHAT" and TacticatorSavings.showInstace))) then
  		--DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Tacticator Display:"..sender)
		local inSender = sender
		local inTactic = text
		local matched = false
		if (TacticatorSavings.showPopupOwn or not(inSender == UnitName("player"))) then
			if TacticatorSavings.showPopup then
				TacticDisplay:Show()
			end
  			if(getn(TACTIC_TEMP_MSG) > 0) then
		  		for i = 1, getn(TACTIC_TEMP_MSG), 1 do
  					if (TACTIC_TEMP_MSG[i].sender == inSender) and not(strsub(TACTIC_TEMP_MSG[i].tactic, strlen(TACTIC_TEMP_MSG[i].tactic))==strchar(23)) then
	  					TACTIC_TEMP_MSG[i].tactic = TACTIC_TEMP_MSG[i].tactic .. inTactic
						matched = true
					end
				end
			end
			if (not matched) then
				local new = {
  					sender = inSender;
  					tactic = inTactic;
  				}
  				TACTIC_TEMP_MSG[getn(TACTIC_TEMP_MSG)+1] = new
  			end
  			if strbyte(TACTIC_TEMP_MSG[getn(TACTIC_TEMP_MSG)].tactic, strlen(TACTIC_TEMP_MSG[getn(TACTIC_TEMP_MSG)].tactic)) == 23 then
	  			TacticDisplayDropDownReceived_Initialize()
	  			lastReceived = getn(TACTIC_TEMP_MSG)
	  			TacticDisplayDropDownReceived_OnShow()
				local box = _G["TacticDisplayScrollContainerScrollFrameEditBox"]
				box:SetText(gsub(TACTIC_TEMP_MSG[lastReceived].tactic, strchar(23), ""))
			end
		end
	end
end

function TacticatorConfigFrame_OnLoad(panel)
    panel.name = "Tacticator " .. GetAddOnMetadata("Tacticator", "Version")
    panel.okay = function(self) TacticatorConfig_Ok(); end
    panel.cancel = function(self)  TacticatorConfig_OnCancelOrLoad();  end
    InterfaceOptions_AddCategory(panel)
end

function TacticatorConfig_Ok()
    TacticatorSavings.showRaid = TacticatorConfigFrameRaid:GetChecked()
    TacticatorSavings.showParty = TacticatorConfigFrameParty:GetChecked()
    TacticatorSavings.showBG = TacticatorConfigFrameBG:GetChecked()
    TacticatorSavings.showInstance = TacticatorConfigFrameInstance:GetChecked()
    TacticatorSavings.showPopup = TacticatorConfigFramePopup:GetChecked()
    TacticatorSavings.showPopupOwn = TacticatorConfigFramePopupOwn:GetChecked()
end

function TacticDisplay_OnCopy()
	local i = getn(TacticatorSavings.TACTIC_INSTANCE)+1
	local box = _G["TacticDisplayScrollContainerScrollFrameEditBox"]
	local nameIn = _G["TacticDisplayName"]:GetText()
	local id = UIDropDownMenu_GetSelectedID(TacticDisplayDropDownReceived)
	if(not nameIn or nameIn == "") then
		nameIn = TACTIC_TEMP_MSG[id].sender..":"..id
	end
	local new = {
		name = nameIn;
		tactic = box:GetText();
	}
	TacticatorSavings.TACTIC_INSTANCE[i] = new
end

function Tacticator_RaidTarget(tag)
	TacticatorScrollContainerScrollFrameEditBox:Insert(tag)
end

function Tacticator_TargetRaidTarget(tag)
	SetRaidTarget("target", tag)
end

function Tacticator_ImportGD()
	local mobname = UnitName("target")
	for mob in pairs(moblist) do
		for nameidx in pairs(moblist[mob].name) do
			if (moblist[mob].name[nameidx]==mobname) then
				Tacticator_DescribeGD(moblist[mob])
				return
			end
		end
		for nameidx in pairs(moblist[mob].shortName) do
			if (moblist[mob].shortName[nameidx]==mobname) then
				Tacticator_DescribeGD(moblist[mob])
				return
			end
		end
	end
  if( DEFAULT_CHAT_FRAME ) then
    DEFAULT_CHAT_FRAME:AddMessage("|cffff2222Mob not found")
  end
end

function Tacticator_DescribeGD(mob)
	for line in pairs(mob.description) do
		TacticatorScrollContainerScrollFrameEditBox:Insert(mob.description[line])
		TacticatorScrollContainerScrollFrameEditBox:Insert(strchar(10))
	end
end

function Tacticator_ActorInsert(act)
	TacticatorScrollContainerScrollFrameEditBox:Insert("{"..act.."}")
end

function Tacticator_ActorCopy(buttonId)
	local box = _G["TacticatorActors"..buttonId]
	local actorName = UnitName("target")
	if (actorName) then
		box:SetText(actorName)
	end
end

function Tacticator_OpenActors()
	if(TacticatorActors:IsShown()) then
		TacticatorActors:Hide()
	else
		TacticatorActors:Show()
		Tacticator_ColourActors()
	end
end

function Tacticator_ColourActors()
	for i = 1, 9, 1 do
		while strsub(_G["TacticatorActorsTankTabT"..i]:GetText(),1,1) == "|" do
			_G["TacticatorActorsTankTabT"..i]:SetText(strsub(_G["TacticatorActorsTankTabT"..i]:GetText(),11))
		end
		while strsub(_G["TacticatorActorsDPSTabD"..i]:GetText(),1,1) == "|" do
			_G["TacticatorActorsDPSTabD"..i]:SetText(strsub(_G["TacticatorActorsDPSTabD"..i]:GetText(),11))
		end
		while strsub(_G["TacticatorActorsHealerTabH"..i]:GetText(),1,1) == "|" do
			_G["TacticatorActorsHealerTabH"..i]:SetText(strsub(_G["TacticatorActorsHealerTabH"..i]:GetText(),11))
		end
		if _G["TacticatorActorsTankTabT"..i]:GetText() and UnitIsPlayer(_G["TacticatorActorsTankTabT"..i]:GetText()) then
			for j = 1, GetNumGroupMembers(), 1 do
				local name, rank, subgroup, level, c, class, zone, online = GetRaidRosterInfo(j)
				if name == _G["TacticatorActorsTankTabT"..i]:GetText() then
					_G["TacticatorActorsTankTabT"..i]:SetText("|c"..RAID_CLASS_COLORS[class].colorStr.._G["TacticatorActorsTankTabT"..i]:GetText())
				elseif not online then
					_G["TacticatorActorsTankTabT"..i]:SetText("|cff555555".._G["TacticatorActorsTankTabT"..i]:GetText())
				end
			end
		else
			_G["TacticatorActorsTankTabT"..i]:SetText("|cff555555".._G["TacticatorActorsTankTabT"..i]:GetText())
		end
		if _G["TacticatorActorsDPSTabD"..i]:GetText() and UnitIsPlayer(_G["TacticatorActorsDPSTabD"..i]:GetText()) then
			for j = 1, GetNumGroupMembers(), 1 do
				local name, rank, subgroup, level, c, class, zone, online = GetRaidRosterInfo(j)
				if name == _G["TacticatorActorsDPSTabD"..i]:GetText() then
					_G["TacticatorActorsDPSTabD"..i]:SetText("|c"..RAID_CLASS_COLORS[class].colorStr.._G["TacticatorActorsDPSTabD"..i]:GetText())
				elseif not online then
					_G["TacticatorActorsDPSTabD"..i]:SetText("|cff555555".._G["TacticatorActorsDPSTabD"..i]:GetText())
				end
			end
		else
			_G["TacticatorActorsDPSTabD"..i]:SetText("|cff555555".._G["TacticatorActorsDPSTabD"..i]:GetText())
		end
		if _G["TacticatorActorsHealerTabH"..i]:GetText() and UnitIsPlayer(_G["TacticatorActorsHealerTabH"..i]:GetText()) then
			for j = 1, GetNumGroupMembers(), 1 do
				local name, rank, subgroup, level, c, class, zone, online = GetRaidRosterInfo(j)
				if name == _G["TacticatorActorsHealerTabH"..i]:GetText() then
					_G["TacticatorActorsHealerTabH"..i]:SetText("|c"..RAID_CLASS_COLORS[class].colorStr.._G["TacticatorActorsHealerTabH"..i]:GetText())
				elseif not online then
					_G["TacticatorActorsHealerTabH"..i]:SetText("|cff555555".._G["TacticatorActorsHealerTabH"..i]:GetText())
				end
			end
		else
			_G["TacticatorActorsHealerTabH"..i]:SetText("|cff555555".._G["TacticatorActorsHealerTabH"..i]:GetText())
		end
	end
end

function TacticButtons_OnClose()
	TacticatorSavings.buttonsShow = false
	TacticButtons:Hide()
end

function TacticButtons_OnLoad(self)
	if TacticatorSavings.buttonsShow then
		TacticButtons:Show()
	else
		TacticButtons:Hide()
	end
end

function TacticButtons_SavePosition(self)
	TacticatorSavings.buttonsDispx = self:GetLeft()
	TacticatorSavings.buttonsDispy = self:GetBottom()
end

function Tacticator_ShowButtons()
	TacticatorSavings.buttonsShow = true
	TacticButtons:Show()
end

function Tacticator_GetChannel()
	local channel
	if(_G["TacticatorCheckParty"]:GetChecked()) then
		channel = "PARTY"
	elseif(_G["TacticatorCheckSay"]:GetChecked()) then
		channel = "SAY"
	elseif(_G["TacticatorCheckRaidWarning"]:GetChecked()) then
		channel = "RAID_WARNING"
	elseif(_G["TacticatorCheckBattleground"]:GetChecked()) then
		channel = "BATTLEGROUND"
	elseif(_G["TacticatorCheckChannelNo"]:GetChecked()) then
		channel = "CHANNEL"
	elseif(_G["TacticatorCheckInstance"]:GetChecked()) then
		channel = "INSTANCE_CHAT"
	else
		channel = "RAID"
	end
	return channel
end

function Tacticator_Send1()
	local id = lastSelected
	local setChannel = Tacticator_GetChannel()
	message1 = {
		message = id;
		channel = setChannel;
	}
	TacticButtonsSend1:SetText(TacticatorSavings.TACTIC_INSTANCE[id].name)
end

function Tacticator_Send2()
	local id = lastSelected
	local setChannel = Tacticator_GetChannel()
	message2 = {
		message = id;
		channel = setChannel;
	}
	TacticButtonsSend2:SetText(TacticatorSavings.TACTIC_INSTANCE[id].name)
end

function Tacticator_Send3()
	local id = lastSelected
	local setChannel = Tacticator_GetChannel()
	message3 = {
		message = id;
		channel = setChannel;
	}
	TacticButtonsSend3:SetText(TacticatorSavings.TACTIC_INSTANCE[id].name)
end

function Tacticator_Send4()
	local id = lastSelected
	local setChannel = Tacticator_GetChannel()
	message4 = {
		message = id;
		channel = setChannel;
	}
	TacticButtonsSend4:SetText(TacticatorSavings.TACTIC_INSTANCE[id].name)
end

function TacticButtons_Send1()
	if message1 then
		TacticatorPrepareMessage(message1.message)
		TacticButtons_SetChannel(message1.channel)
		Tacticator_OnSend()
	end
end

function TacticButtons_Send2()
	if message2 then
		TacticatorPrepareMessage(message2.message)
		TacticButtons_SetChannel(message2.channel)
		Tacticator_OnSend()
	end
end

function TacticButtons_Send3()
	if message3 then
		TacticatorPrepareMessage(message3.message)
		TacticButtons_SetChannel(message3.channel)
		Tacticator_OnSend()
	end
end

function TacticButtons_Send4()
	if message4 then
		TacticatorPrepareMessage(message4.message)
		TacticButtons_SetChannel(message4.channel)
		Tacticator_OnSend()
	end
end

function TacticButtons_SetChannel(channel)
	if channel == "PARTY" then
		Tacticator_OnPartyClick()
	elseif channel == "SAY" then
		Tacticator_OnSayClick()
	elseif channel == "RAID" then
		Tacticator_OnRaidClick()
	elseif channel == "RAID_WARNING" then
		Tacticator_OnRaidWarningClick()
	elseif channel == "BATTLEGROUND" then
		Tacticator_OnBattlegroundClick()
	elseif channel == "CHANNEL" then
		Tacticator_OnChannelNoClick()
	elseif channel == "INSTANCE_CHAT" then
		Tacticator_OnInstanceClick()
	end
end

function Tacticator_InstanceScrollBar_Update()
	local line
	local lineplusoffset
	FauxScrollFrame_Update(TacticatorListInstanceScrollFrame, #(TacticatorSavings.TACTIC_INSTANCE), 1, 12)
	for line=1,20 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(TacticatorListInstanceScrollFrame)
		if lineplusoffset <= #(TacticatorSavings.TACTIC_INSTANCE) then
			if(strlen(TacticatorSavings.TACTIC_INSTANCE[lineplusoffset].name) > 12) then
				text = strsub(TacticatorSavings.TACTIC_INSTANCE[lineplusoffset].name,1,12).."..."
			else
				text = TacticatorSavings.TACTIC_INSTANCE[lineplusoffset].name
			end
			_G["TacticatorListInstanceScrollFrame"..line]:SetText(text)
			_G["TacticatorListInstanceScrollFrame"..line]:Show()
			if lineplusoffset == lastSelected then
				_G["TacticatorListInstanceScrollFrame"..line]:LockHighlight()
			else
				_G["TacticatorListInstanceScrollFrame"..line]:UnlockHighlight()
			end
		else
			_G["TacticatorListInstanceScrollFrame"..line]:Hide()
		end
	end
end

function TacticatorListInstanceScrollBar_OnClick(self)
	local thisID = self:GetID()
	if lastSelected > 0 then
		local oldSelected = lastSelected - FauxScrollFrame_GetOffset(TacticatorListInstanceScrollFrame)
		if oldSelected > 0 and oldSelected <= 20 then
			_G["TacticatorListInstanceScrollFrame"..oldSelected]:UnlockHighlight()
		end
	end
	self:LockHighlight()
	lineplusoffset = thisID + FauxScrollFrame_GetOffset(TacticatorListInstanceScrollFrame)
	TacticatorPrepareMessage(lineplusoffset)
end

function Tacticator_SetHook()
	--DEFAULT_CHAT_FRAME:AddMessage("Hooking for Tacticator")
	TacticatorOld_ChatEdit_InsertLink = ChatEdit_InsertLink
	ChatEdit_InsertLink = function(text)
		--ChatEdit_InsertLink = TacticatorOld_ChatEdit_InsertLink
		return Tacticator_InsertLink(text) or TacticatorOld_ChatEdit_InsertLink(text)
	end
	hooksecurefunc("CreateFrame",Tacticator_CreateHookedFrame)
end

function Tacticator_InsertJournalLink(self, button)
	local box = _G["TacticatorScrollContainerScrollFrameEditBox"]
	if box:HasFocus() and self.link and IsModifiedClick("CHATLINK") then
		Tacticator_InsertLink(self.link)
	end
end

function Tacticator_InsertLink(text)
	--DEFAULT_CHAT_FRAME:AddMessage("Link:"..text)
	local box = _G["TacticatorScrollContainerScrollFrameEditBox"]
	if box:HasFocus() then
		local _, _, _, _, itemId = string.find(text, "|?c?f?f?(%x*)|?Hitem?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
		local _, _, _, _, spellId = string.find(text, "|?c?f?f?(%x*)|?Hspell?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
		local _, _, _, _, typeId, encounterId, difficulty, name = string.find(text, "|?c?f?f?(%x*)|?Hjournal?([^:]*):?(%d+):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
		local outText
		if itemId then
			name = GetItemInfo(itemId)
			outText = "{item:"..itemId..":"..name.."}"
		end
		if spellId then
			name = GetSpellInfo(spellId)
			outText = "{spell:"..spellId..":"..name.."}"
		end
		if encounterId then
			outText = "{journal:"..typeId..":"..encounterId..":"..name.."}"
		end
		--DEFAULT_CHAT_FRAME:AddMessage("Old text:"..tacticText)
		local tacticText = box:GetText()
		local position = box:GetUTF8CursorPosition()
		local newPosition = strlen(outText)
		if position > 1 then
			outText = string.sub(tacticText, 1, position)..outText
			newPosition = strlen(outText)
			if strlen(tacticText) > position then
				outText = outText..string.sub(tacticText, position+1)
			end
		else
			newPosition = strlen(outText)
		end
		box:SetText(outText)
		box:SetCursorPosition(newPosition)
		return true
	else
		return false
	end
end